Index: s390-tools-sles11/dasdview/dasdview.c
===================================================================
--- s390-tools-sles11.orig/dasdview/dasdview.c
+++ s390-tools-sles11/dasdview/dasdview.c
@@ -1496,7 +1654,7 @@ int main(int argc, char * argv[]) {
 	else
 		info.begin = DEFAULT_BEGIN;
 
-	max = (unsigned long long) info.geo.cylinders *
+	max = (unsigned long long) info.hw_cylinders *
 		(unsigned long long) info.geo.heads *
 		(unsigned long long) info.geo.sectors *
 		(unsigned long long) info.blksize;
@@ -1585,10 +1743,23 @@ int main(int argc, char * argv[]) {
 	        dasdview_print_vtoc_f1(&info);
 	}
 
+	if (info.vtoc_f8 || info.vtoc_all)
+	{
+	        dasdview_print_vtoc_f8(&info);
+	}
+
+	if (info.vtoc_f9 || info.vtoc_all)
+	{
+	        dasdview_print_vtoc_f9(&info);
+	}
+
 	if (!info.action_specified)
 	{
 		printf("No action specified.\n");
 	}
 
+	if (info.characteristic_specified)
+		dasdview_print_characteristic(&info);
+
 	return 0;
 }
Index: s390-tools-sles11/dasdview/dasdview.h
===================================================================
--- s390-tools-sles11.orig/dasdview/dasdview.h
+++ s390-tools-sles11/dasdview/dasdview.h
@@ -97,21 +97,11 @@ typedef struct dasd_information2_t {
 #define BIODASDINFO2   _IOR(DASD_IOCTL_LETTER,3,dasd_information2_t)
 
 /********************************************************************************
- * SECTION: Further IOCTL Definitions  (see fs.h)
+ * SECTION: Further IOCTL Definitions  (see fs.h and hdreq.h)
  *******************************************************************************/
 /* get block device sector size */
 #define BLKSSZGET  _IO(0x12,104)
-
-/********************************************************************************
- * SECTION: Definition from hdreq.h
- *******************************************************************************/
-
-struct hd_geometry {
-      unsigned char heads;
-      unsigned char sectors;
-      unsigned short cylinders;
-      unsigned long start;
-};
+#define BLKGETSIZE64 _IOR(0x12,114,size_t) /* return device size in bytes (u64 *arg) */
 
 /* get device geometry */
 #define HDIO_GETGEO		0x0301
@@ -126,7 +116,7 @@ struct hd_geometry {
 #define DASDVIEW_ERROR "dasdview:"
 #define DEFAULT_BEGIN 0
 #define DEFAULT_SIZE 128
-#define NO_F1_LABELS 8
+#define NO_PART_LABELS 8 /* for partition related labels (f1,f8 and f9) */
 #define SEEK_STEP 4194304LL
 #define DUMP_STRING_SIZE 1024LL
 
@@ -158,6 +148,7 @@ typedef struct dasdview_info
 	int blksize;
 	int devno;
 	struct hd_geometry geo;
+	u_int32_t hw_cylinders;
 
 	unsigned long long begin;
 	unsigned long long size;
@@ -169,6 +160,7 @@ typedef struct dasdview_info
 	int node_specified;
 	int begin_specified;
 	int size_specified;
+	int characteristic_specified;
 	int device_id;
 	int general_info;
 	int extended_info;
@@ -179,21 +171,27 @@ typedef struct dasdview_info
 	int vtoc_f4;
 	int vtoc_f5;
 	int vtoc_f7;
+	int vtoc_f8;
+	int vtoc_f9;
 	int vtoc_all;
 	int vlabel_info;
 
-	format1_label_t f1[NO_F1_LABELS];
+	format1_label_t f1[NO_PART_LABELS];
 	format4_label_t f4;
 	format5_label_t f5;
 	format7_label_t f7;
+	format1_label_t f8[NO_PART_LABELS];
+	format9_label_t f9[NO_PART_LABELS];
 	int f1c;
 	int f4c;
 	int f5c;
 	int f7c;
+	int f8c;
+	int f9c;
 } dasdview_info_t;
 
 
-#define dasdview_getopt_string "t:n:f:b:s:vhixjl12"
+#define dasdview_getopt_string "t:n:f:b:s:vhixjl12c"
 
 /* struct options for getopt */
 static struct option dasdview_getopt_long_options[]=
@@ -209,6 +207,7 @@ static struct option dasdview_getopt_lon
 	{ "volser",      0, 0, 'j'},
 	{ "vtoc",        1, 0, 't'},
 	{ "label",       0, 0, 'l'},
+	{ "characteristic", 0, 0, 'c'},
 	{0, 0, 0, 0}
 };
 
Index: s390-tools-sles11/etc/init.d/dumpconf
===================================================================
--- s390-tools-sles11.orig/etc/init.d/dumpconf
+++ s390-tools-sles11/etc/init.d/dumpconf
@@ -13,6 +13,7 @@
 # chkconfig: 12345 01 99
 
 DUMP_CONFIG_FILE=/etc/sysconfig/dumpconf
+ERRMSG="Check $DUMP_CONFIG_FILE!"
 
 RETVAL=0
 
@@ -74,8 +75,8 @@ EOF
 printversion()
 {
     cat <<EOF
-dumpconf: zSeries dump configuration script version 1.1.
-Copyright IBM Corp. 2006, 2008.
+dumpconf: zSeries dump configuration script version 1.1
+Copyright IBM Corp. 2006, 2009
 EOF
 }
 
@@ -117,18 +118,77 @@ verify_ccw_dump_device()
 	fi
 }
 
-setup_ccw_device()
-{
-	echo $DEVICE > $1/ccw/device || RETVAL=1
+#------------------------------------------------------------------------------
+# Helper function to check a device string.
+#------------------------------------------------------------------------------
+function CheckDeviceString() {
+	local X
+
+	X=$(
+		echo "$1" |
+		awk --posix -F. '
+			function PrintBusID(css, grp, devno) {
+				while(length(devno) < 4)
+					devno = "0" devno
+				print css "." grp "." devno
+			}
+			NF == 1 && $1 ~ /^[0-9a-fA-F]{1,4}$/ {
+				PrintBusID("0","0", $1)
+				next
+			}
+			NF != 3 || $1 !~ /^[0-9a-fA-F]{1,2}$/ {
+				next
+			}
+			$2 !~ /^[0-9a-fA-F]{1,2}$/ {
+				next
+			}
+			$3 !~ /^[0-9a-fA-F]{1,4}$/ {
+				next
+			}
+			{
+				PrintBusID($1, $2, $3)
+			}
+		'
+		)
+
+	if [ "$X" != "" ]; then
+		echo $X
+		return 0
+	fi
 }
 
-setup_fcp_device()
+setup_device()
 {
-	echo $DEVICE > $1/fcp/device || RETVAL=1
-	echo $WWPN > $1/fcp/wwpn || RETVAL=1
-	echo $LUN > $1/fcp/lun || RETVAL=1
-	echo $BOOTPROG > $1/fcp/bootprog || RETVAL=1
-	echo $BR_LBA > $1/fcp/br_lba || RETVAL=1
+	DEV="$(CheckDeviceString $DEVICE)"
+	if [ "$DEV" != "" ]; then
+		echo $DEV > $1/$2/device
+	else
+		RETVAL=1
+		echo "ERROR: Invalid DEVICE '$DEVICE'." $ERRMSG >&2
+		return
+	fi
+	if [ $2 == "fcp" ]; then
+		echo $WWPN > $1/fcp/wwpn 2>/dev/null || RETVAL=1
+		if [ $RETVAL -eq 1 ]; then
+			echo "ERROR: Invalid WWPN '$WWPN'." $ERRMSG >&2
+			return
+		fi
+		echo $LUN > $1/fcp/lun 2>/dev/null || RETVAL=1
+		if [ $RETVAL -eq 1 ]; then
+			echo "ERROR: Invalid LUN '$LUN'." $ERRMSG >&2
+			return
+		fi
+		echo $BOOTPROG > $1/fcp/bootprog 2>/dev/null || RETVAL=1
+		if [ $RETVAL -eq 1 ]; then
+			echo "ERROR: Invalid BOOTPROG '$BOOTPROG'." $ERRMSG >&2
+			return
+		fi
+		echo $BR_LBA > $1/fcp/br_lba 2>/dev/null || RETVAL=1
+		if [ $RETVAL -eq 1 ]; then
+			echo "ERROR: Invalid BR_LBA '$BR_LBA'." $ERRMSG >&2
+			return
+		fi
+	fi
 }
 
 setup_nss_device()
@@ -143,23 +203,20 @@ setup_reipl()
 		return
 	fi
 
-	if [ "$REIPL_TYPE" == "ccw" ]; then
-		setup_ccw_device $REIPL_CONFIG_DIR
-	elif [ "$REIPL_TYPE" == "fcp" ]; then
-		setup_fcp_device $REIPL_CONFIG_DIR
+	if [ "$REIPL_TYPE" == "ccw" ] || [ "$REIPL_TYPE" == "fcp" ]; then
+		setup_device $REIPL_CONFIG_DIR $REIPL_TYPE
 	elif [ "$REIPL_TYPE" == "nss" ]; then
 		setup_nss_device $REIPL_CONFIG_DIR
 	else
-		echo "ERROR: Unknown reipl type '$REIPL_TYPE'" >&2
+		echo "ERROR: Unknown reipl type '$REIPL_TYPE'." $ERRMSG >&2
 		RETVAL=1
+		return
 	fi
 
 	echo $REIPL_TYPE > $REIPL_CONFIG_DIR/reipl_type || RETVAL=1
 
 	if [ $RETVAL -eq 1 ]; then
-		echo "ERROR: Setup of $REIPL_TYPE reipl device failed." >&2
-		echo none > $REIPL_CONFIG_DIR/reipl_type
-		return $RETVAL
+		return
 	fi
 
 	echo "$REIPL_TYPE reipl device configured."
@@ -167,28 +224,22 @@ setup_reipl()
 
 setup_dump()
 {
-	if [ "$DUMP_TYPE" == "ccw" ]; then
-		setup_ccw_device $DUMP_CONFIG_DIR
-	elif [ "$DUMP_TYPE" == "fcp" ]; then
-		setup_fcp_device $DUMP_CONFIG_DIR
+	if [ "$DUMP_TYPE" == "ccw" ] || [ "$DUMP_TYPE" == "fcp" ]; then
+		setup_device $DUMP_CONFIG_DIR $DUMP_TYPE
 	elif [ "$DUMP_TYPE" != "none" ]; then
-		echo "ERROR: Unknown dump type '$DUMP_TYPE'" >&2
+		echo "ERROR: Unknown dump type '$DUMP_TYPE'." $ERRMSG >&2
 		RETVAL=1
+		return
 	fi
 
 	echo $DUMP_TYPE > $DUMP_CONFIG_DIR/dump_type || RETVAL=1
 
 	if [ $RETVAL -eq 1 ]; then
-		echo "ERROR: Setup of $DUMP_TYPE dump device failed." >&2
 		echo none > $DUMP_CONFIG_DIR/dump_type
-		return $RETVAL
+		return
 	fi
 
-	if [ "$CONF_DUMP_TYPE" == "none" ]; then
-		echo "No dump device configured. "
-	else
-		echo "dump on panic configured: Using $DUMP_TYPE device."
-	fi
+	echo "$ON_PANIC on panic configured: Using $DUMP_TYPE dump device."
 }
 
 setup_on_panic_vmcmd()
@@ -207,7 +258,7 @@ setup_on_panic_vmcmd()
 		echo "ERROR: No vmcmd support. Are you running on LPAR?" >&2
 		RETVAL=1
 	elif [ "$VMCMD" == "" ]; then
-		echo "ERROR: No vmcmd for panic specified!" >&2
+		echo "ERROR: No VMCMD_x keyword specified." $ERRMSG >&2
 		RETVAL=1
 	else
 		echo -en "$VMCMD" | cat > $VMCMD_CONFIG_DIR/on_panic || RETVAL=1
@@ -221,23 +272,28 @@ setup_on_panic_vmcmd()
 
 print_fcp_device()
 {
-	echo "device..: $(cat $1/fcp/device)" || RETVAL=1
-	echo "wwpn....: $(cat $1/fcp/wwpn)" || RETVAL=1
-	echo "lun.....: $(cat $1/fcp/lun)" || RETVAL=1
-	echo "bootprog: $(cat $1/fcp/bootprog)" || RETVAL=1
-	echo "br_lba..: $(cat $1/fcp/br_lba)" || RETVAL=1
+	DEVICE=$(cat $1/fcp/device) || RETVAL=1
+	echo "device..: $DEVICE"
+	WWPN=$(cat $1/fcp/wwpn) || RETVAL=1
+	echo "wwpn....: $WWPN"
+	LUN=$(cat $1/fcp/lun) || RETVAL=1
+	echo "lun.....: $LUN"
+	BOOTPROG=$(cat $1/fcp/bootprog) || RETVAL=1
+	echo "bootprog: $BOOTPROG"
+	BR_LBA=$(cat $1/fcp/br_lba) || RETVAL=1
+	echo "br_lba..: $BR_LBA"
 }
 
 print_ccw_device()
 {
-	DEVICE=$(cat $1/ccw/device)
-	echo "device..: $DEVICE" || RETVAL=1
+	DEVICE=$(cat $1/ccw/device) || RETVAL=1
+	echo "device..: $DEVICE"
 }
 
 print_nss_name()
 {
-	NAME=$(cat $1/nss/device)
-	echo "device..: $NAME" || RETVAL=1
+	NAME=$(cat $1/nss/device) || RETVAL=1
+	echo "device..: $NAME"
 }
 
 status_dump()
@@ -246,14 +302,14 @@ status_dump()
 	if [ "$CONF_DUMP_TYPE" == "none" ]; then
 		echo "type....: no dump device configured"
 	elif [ "$CONF_DUMP_TYPE" == "ccw" ]; then
-		echo "type....: $(cat $DUMP_CONFIG_DIR/dump_type)" || RETVAL=1
+		echo "type....: ccw"
 		print_ccw_device $DUMP_CONFIG_DIR
 		verify_ccw_dump_device $(cat $DUMP_CONFIG_DIR/ccw/device)
 	elif [ "$CONF_DUMP_TYPE" == "fcp" ]; then
-		echo "type....: $(cat $DUMP_CONFIG_DIR/dump_type)" || RETVAL=1
+		echo "type....: fcp"
 		print_fcp_device $DUMP_CONFIG_DIR
 	else
-		echo "ERROR: Unknown dump device type '$TYPE'!" >&2
+		echo "ERROR: Unknown dump device type '$CONF_DUMP_TYPE'!" >&2
 		echo "       Please check if you have the latest dumpconf package!" >&2
 	fi
 }
@@ -261,7 +317,7 @@ status_dump()
 status_reipl()
 {
 	REIPL_TYPE=$(cat $REIPL_CONFIG_DIR/reipl_type) || RETVAL=1
-	echo "type....: $(cat $REIPL_CONFIG_DIR/reipl_type)" || RETVAL=1
+	echo "type....: $REIPL_TYPE"
 	if [ "$REIPL_TYPE" == "ccw" ]; then
 		print_ccw_device $REIPL_CONFIG_DIR
 	elif [ "$REIPL_TYPE" == "fcp" ]; then
@@ -274,11 +330,20 @@ status_reipl()
 	fi
 }
 
+status_dump_reipl()
+{
+	echo -e "\ndump:"
+	status_dump
+	echo -e "\nreipl:"
+	status_reipl
+}
+
+
 status_vmcmd()
 {
 	VMCMD=$(cat $VMCMD_CONFIG_DIR/on_panic) || RETVAL=1
 	if [ "$VMCMD" == "" ]; then
-		echo "WARNING: No VM command specied!"
+		echo "WARNING: No VM command specified!"
 	else
 		echo "---------------"
 		echo "$VMCMD"
@@ -293,26 +358,27 @@ start()
 
 	if [ "$ON_PANIC" == "reipl" ]; then
 		setup_reipl
-	elif [ "$ON_PANIC" == "dump" ]; then
+	elif [ "$ON_PANIC" == "dump" ] || [ "$ON_PANIC" == "dump_reipl" ]; then
 		setup_dump
 	elif [ "$ON_PANIC" == "vmcmd" ]; then
 		setup_on_panic_vmcmd
 	elif [ "$ON_PANIC" == "stop" ]; then
 		echo "stop on panic configured."
 	else
-		echo "ERROR: Unknown 'on panic' type '$ON_PANIC'" >&2
+		echo "ERROR: Unknown 'on panic' type '$ON_PANIC'." $ERRMSG >&2
 		RETVAL=1
 	fi
+	if [ $RETVAL -eq 1 ]; then
+		return $RETVAL
+	fi
 
-	echo $ON_PANIC > $ON_PANIC_CONFIG_FILE || RETVAL=1
+	echo $ON_PANIC > $ON_PANIC_CONFIG_FILE 2> /dev/null || RETVAL=1
 
 	# check for errors
 
 	if [ $RETVAL -eq 1 ]; then
-		ERRMSG="\"on panic action\" configuration failed!"
 		echo stop > $ON_PANIC_CONFIG_FILE
-		echo "ERROR: $ERRMSG Check $DUMP_CONFIG_FILE!" >&2
-		return $RETVAL
+		echo "ERROR: $ON_PANIC not supported by hardware!" >&2
 	fi
 
 	return $RETVAL
@@ -340,6 +406,8 @@ status()
 		status_reipl
 	elif [ "$ON_PANIC" == "dump" ]; then
 		status_dump
+	elif [ "$ON_PANIC" == "dump_reipl" ]; then
+		status_dump_reipl
 	elif [ "$ON_PANIC" != "stop" ]; then
 		echo "ERROR: Unknown on_panic type '$ON_PANIC'" >&2
 	fi
Index: s390-tools-sles11/etc/sysconfig/dumpconf
===================================================================
--- s390-tools-sles11.orig/etc/sysconfig/dumpconf
+++ s390-tools-sles11/etc/sysconfig/dumpconf
@@ -5,16 +5,19 @@
 #
 # The following actions are supported:
 #
-# * stop:  Stop Linux (default)
-# * dump:  Dump Linux
-# * vmcmd: Issue z/VM CP commands
-# * reipl: Reboot Linux using setting under /sys/firmware/reipl
+# * stop:       Stop Linux (default)
+# * dump:       Dump Linux
+# * vmcmd:      Issue z/VM CP commands
+# * reipl:      Re-IPL Linux using setting under /sys/firmware/reipl
+# * dump_reipl: First dump Linux, then re-IPL Linux using setting under
+#               /sys/firmware/reipl
 #
 
 #
-# Dump on ccw device (DASD)
+# Dump on ccw device (DASD) and re-IPL after dump is complete.
+# The re-IPL device, as specified under "/sys/firmware/reipl", is used.
 #
-# ON_PANIC=dump
+# ON_PANIC=dump_reipl
 # DUMP_TYPE=ccw
 # DEVICE=0.0.4e13
 
@@ -43,7 +46,7 @@
 # ON_PANIC=stop
 
 #
-# Reipl on panic
-# The reipl device, as specified under "/sys/firmware/reipl", is used.
+# Re-IPL on panic
+# The re-IPL device, as specified under "/sys/firmware/reipl", is used.
 #
 # ON_PANIC=reipl
